package hideandseek.utils;

import java.util.regex.Matcher;
import hideandseek.HideAndSeek;
import org.bukkit.inventory.Inventory;
import hideandseek.Config;
import org.bukkit.Sound;
import java.util.Optional;
import org.bukkit.enchantments.Enchantment;
import org.bukkit.potion.PotionType;
import hideandseek.xseries.XMaterial;
import org.bukkit.inventory.ItemStack;
import org.bukkit.Location;
import java.util.Iterator;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Collection;
import org.bukkit.World;
import org.bukkit.Bukkit;
import com.google.common.collect.Lists;
import org.bukkit.entity.Player;
import java.util.List;
import java.util.regex.Pattern;
import org.bukkit.ChatColor;
import java.util.Random;

public class Utils
{
    public static final Random random;
    private static final ChatColor[] goodColors;
    private static final Pattern HEX_PATTERN;
    
    static {
        random = new Random();
        goodColors = new ChatColor[] { ChatColor.DARK_AQUA, ChatColor.GOLD, ChatColor.GRAY, ChatColor.BLUE, ChatColor.GREEN, ChatColor.AQUA, ChatColor.RED, ChatColor.LIGHT_PURPLE, ChatColor.YELLOW };
        HEX_PATTERN = Pattern.compile("&#[a-fA-F0-9]{6}");
    }
    
    public static ChatColor getGoodColor() {
        return Utils.goodColors[Utils.random.nextInt(Utils.goodColors.length)];
    }
    
    public static List<Player> getOnlinePlayers() {
        final ArrayList<Player> var0 = Lists.newArrayList();
        for (final World var3 : Bukkit.getWorlds()) {
            var0.addAll(var3.getPlayers());
        }
        return Collections.unmodifiableList((List<? extends Player>)var0);
    }
    
    public static ArrayList<Player> getPlayers(final Collection<String> var0) {
        final ArrayList<Player> var = new ArrayList<Player>();
        for (final String var3 : var0) {
            final Player var4 = Bukkit.getPlayer(var3);
            if (var4 != null) {
                var.add(var4);
            }
        }
        return var;
    }
    
    public static boolean isNumber(final String var0) {
        try {
            Integer.parseInt(var0);
            return true;
        }
        catch (final NumberFormatException var) {
            return false;
        }
    }
    
    public static List<Location> getCircle(final Location var0, final Integer var1, final Integer var2, final Boolean var3, final Boolean var4, final int var5) {
        final ArrayList<Location> var6 = new ArrayList<Location>();
        final int var7 = var0.getBlockX();
        final int var8 = var0.getBlockY();
        final int var9 = var0.getBlockZ();
        for (int var10 = var7 - var1; var10 <= var7 + var1; ++var10) {
            for (int var11 = var9 - var1; var11 <= var9 + var1; ++var11) {
                for (int var12 = var4 ? (var8 - var1) : var8; var12 < (var4 ? (var8 + var1) : (var8 + var2)); ++var12) {
                    final double var13 = (var7 - var10) * (var7 - var10) + (var9 - var11) * (var9 - var11) + (var4 ? ((var8 - var12) * (var8 - var12)) : 0);
                    if (var13 < var1 * var1 && (!var3 || var13 >= (var1 - 1) * (var1 - 1))) {
                        final Location var14 = new Location(var0.getWorld(), (double)var10, (double)(var12 + var5), (double)var11);
                        var6.add(var14);
                    }
                }
            }
        }
        return var6;
    }
    
    public static ArrayList<Location> getPlatForm(final Location var0) {
        final ArrayList<Location> var = new ArrayList<Location>();
        var.add(var0.clone());
        var.add(var0.clone().add(-1.0, 0.0, 0.0));
        var.add(var0.clone().add(0.0, 0.0, -1.0));
        var.add(var0.clone().add(1.0, 0.0, 0.0));
        var.add(var0.clone().add(0.0, 0.0, 1.0));
        var.add(var0.clone().add(-1.0, 0.0, -1.0));
        var.add(var0.clone().add(1.0, 0.0, -1.0));
        var.add(var0.clone().add(1.0, 0.0, 1.0));
        var.add(var0.clone().add(-1.0, 0.0, 1.0));
        return var;
    }
    
    public static ArrayList<Location> getRoom(final Location var0) {
        final ArrayList<Location> var = new ArrayList<Location>();
        var0.add(0.0, 9.0, 0.0);
        var.addAll(getPlatForm(var0));
        for (int var2 = 0; var2 < 3; ++var2) {
            var0.add(0.0, 1.0, 0.0);
            var.add(var0.clone().add(0.0, 0.0, -2.0));
            var.add(var0.clone().add(0.0, 0.0, 2.0));
            var.add(var0.clone().add(2.0, 0.0, 0.0));
            var.add(var0.clone().add(-2.0, 0.0, 0.0));
            var.add(var0.clone().add(1.0, 0.0, 2.0));
            var.add(var0.clone().add(-1.0, 0.0, 2.0));
            var.add(var0.clone().add(-2.0, 0.0, 1.0));
            var.add(var0.clone().add(-2.0, 0.0, -1.0));
            var.add(var0.clone().add(-1.0, 0.0, -2.0));
            var.add(var0.clone().add(1.0, 0.0, -2.0));
            var.add(var0.clone().add(2.0, 0.0, -1.0));
            var.add(var0.clone().add(2.0, 0.0, 1.0));
        }
        var.addAll(getPlatForm(var0.add(0.0, 1.0, 0.0)));
        return var;
    }
    
    public static ItemStack getItemStack(final String var0, final boolean var1, final boolean var2) {
        final String[] var3 = var0.split(" : ");
        final String var4 = var3[0].toUpperCase();
        ItemStackBuilder var5 = null;
        if (var5 == null) {
            Optional<XMaterial> var6 = XMaterial.matchXMaterial(var4);
            if (!var6.isPresent() && var4.contains(":")) {
                var6 = XMaterial.matchXMaterial(var4.split(":")[0]);
            }
            var5 = new ItemStackBuilder(var6.get().parseItem());
            if (var3[0].contains(":")) {
                final String var7 = var4.split(":")[0];
                if ((var7.contains("POTION") || var7.equals("TIPPED_ARROW")) && var4.split(":").length == 4) {
                    var5.setPotionEffect(PotionType.valueOf(var4.split(":")[1]), Boolean.valueOf(var3[0].split(":")[2]), Boolean.valueOf(var3[0].split(":")[3]));
                }
                else {
                    var5.setDurability(Integer.parseInt(var4.split(":")[1]));
                }
            }
        }
        if (var1) {
            var5.setAmount(Integer.parseInt(var3[1]));
        }
        if (var2) {
            for (int var8 = var1 ? 2 : 1; var8 < var3.length; ++var8) {
                final String var7 = var3[var8].split(":")[0].toLowerCase();
                if (var7.equals("name")) {
                    var5.setName(colorize(var3[var8].split(":")[1]));
                }
                else if (var7.equals("lore")) {
                    var5.addLore(colorize(var3[var8].split(":")[1]));
                }
                else if (var7.equals("enchant")) {
                    var5.addEnchantment(Enchantment.getByName(var3[var8].split(":")[1].toUpperCase()), Integer.parseInt(var3[var8].split(":")[2]));
                }
            }
        }
        return var5.build();
    }
    
    public static int getRandomFromInterval(final int var0, final int var1) {
        return (var1 - var0 > 0) ? (Utils.random.nextInt(var1 - var0 + 1) + var0) : var0;
    }
    
    public static void error(final String var0) {
        Bukkit.getConsoleSender().sendMessage(String.valueOf(ChatColor.RED) + "[躲猫猫] " + var0);
    }
    
    public static void playSound(final Player var0, final String var1) {
        final Sound var2 = Config.getInstance().sounds.get(var1);
        if (var2 != null) {
            var0.playSound(var0.getLocation(), var2, 1.0f, 1.0f);
        }
    }
    
    public static boolean compareItem(final ItemStack var0, final ItemStack var1) {
        return var0 != null && var1 != null && var0.getType().equals((Object)var1.getType()) && var0.getItemMeta().equals(var1.getItemMeta());
    }
    
    public static void cageInventory(final Inventory var0, final boolean var1) {
        final ItemStack var2 = HideAndSeek.getInstance().locked;
        if (var1) {
            for (int var3 = 0; var3 < var0.getSize(); ++var3) {
                var0.setItem(var3, var2);
            }
        }
        else {
            for (int var3 = 0; var3 < 9; ++var3) {
                var0.setItem(var3, var2);
            }
            for (int var3 = var0.getSize() - 9; var3 < var0.getSize(); ++var3) {
                var0.setItem(var3, var2);
            }
            int var3 = var0.getSize() / 9 - 2;
            if (var3 >= 1) {
                for (int var4 = 9; var4 < 9 * var3 + 1; var4 += 9) {
                    var0.setItem(var4, var2);
                }
                for (int var4 = 17; var4 < 9 * (var3 + 1); var4 += 9) {
                    var0.setItem(var4, var2);
                }
            }
        }
    }
    
    public static String colorize(String var0) {
        for (Matcher var = Utils.HEX_PATTERN.matcher(var0); var.find(); var = Utils.HEX_PATTERN.matcher(var0)) {
            final String var2 = var0.substring(var.start(), var.end());
            final String var3 = var2.replace("&#", "x");
            final char[] var4 = var3.toCharArray();
            final StringBuilder var5 = new StringBuilder();
            final char[] var6 = var4;
            for (int var7 = var4.length, var8 = 0; var8 < var7; ++var8) {
                final char var9 = var6[var8];
                var5.append("&").append(var9);
            }
            var0 = var0.replace(var2, var5.toString());
        }
        return ChatColor.translateAlternateColorCodes('&', var0);
    }
}
